
   NMB=12;
   STRG=cell(NMB,1);
   param=zeros(NMB,3);
   STRG{1} ='V-cycle, 1 pre, 0 post (smoothing)'; param( 1,:)=[1 1 0];
   STRG{2} ='V-cycle, 2 pre, 0 post (smoothing)'; param( 2,:)=[1 2 0];
   STRG{3} ='V-cycle, 1 pre, 1 post (smoothing)'; param( 3,:)=[1 1 1];
   STRG{4} ='V-cycle, 0 pre, 1 post (smoothing)'; param( 4,:)=[1 0 1];
   STRG{5} ='V-cycle, 0 pre, 2 post (smoothing)'; param( 5,:)=[1 0 2];
   STRG{6} ='V-cycle, 2 pre, 2 post (smoothing)'; param( 6,:)=[1 2 2];
   STRG{7} ='W-cycle, 1 pre, 0 post (smoothing)'; param( 7,:)=[2 1 0];
   STRG{8} ='W-cycle, 2 pre, 0 post (smoothing)'; param( 8,:)=[2 2 0];
   STRG{9} ='W-cycle, 1 pre, 1 post (smoothing)'; param( 9,:)=[2 1 1];
   STRG{10}='W-cycle, 0 pre, 1 post (smoothing)'; param(10,:)=[2 0 1];
   STRG{11}='W-cycle, 0 pre, 2 post (smoothing)'; param(11,:)=[2 0 2];
   STRG{12}='W-cycle, 2 pre, 2 post (smoothing)'; param(12,:)=[2 2 2];


   type=menu('Multigrid combination',STRG);

   
   % number of coarse grid correction steps
   mu=param(type,1);
   % number of pre-smoothing steps
   nu1=param(type,2);
   % number of post-smoothing steps
   nu2=param(type,3);
   % maximum of pre and post-smoothing, needed for CG
   nu=max(nu1,nu2);
   % ------------------------------------------



   
   fprintf('number of smoothing steps: %1d (pre), %1d (post)\n',nu1,nu2);
   fprintf('number of recursive calls: %1d ', mu);
   if mu==1
      fprintf('(V-cycle)');
   elseif mu==2
      fprintf('(W-cycle)');
   end % if-else
   fprintf('\n\n');

   % right hand side
   b=randn(n,1);

   
   % -------------------------   linear iteration   -------------------------
   % -------------------------   linear iteration   -------------------------
   type_iteration=0;
   while type_iteration<3
         type_iteration=menu('Art des Iterationsverfahrens',...
                             'lineare Iteration',...
                             'cg bzw. GMRES(20)',...
                             'ENDE');

         if type_iteration==1
            fprintf('linear iteration\n');

            for i=1:2
                x=zeros(n,1);
                % nrm=norm(b-Alist{1}*x,inf);
                nrm=norm(b,inf);
                nrm_0=nrm;
                it=0;
                flops(0);
                while nrm>=sqrt(eps)*nrm_0
                     if i==1
                        % 1. Damped diagonal smoothing
                        x=MGCall(b,x,Alist,Plist,Plist,nu1,nu2,mu,'Smoother',Dlist);
                     elseif i==2
                        % 2. Gauss-Seidel smoothing (if post-smoothing is performed,
                        % than in reverse order)
                        if nu1>0 & nu2>0
                           x=MGCall(b,x,Alist,Plist,Plist,nu1,nu2,mu,'SSmoother',GSFlist,'SSmoother',GSBlist);
                        else
                           x=MGCall(b,x,Alist,Plist,Plist,nu1,nu2,mu,'SSmoother',GSFlist);
                        end % if-else
                     end % if-elseif-else
                     nrm=norm(b-Alist{1}*x,inf);
        %             fprintf('%12.4e\n',nrm/nrm_0);
                     it=it+1;
               end % while
               if i==1
                  fprintf('standard Diagonal smoothing, #it: %4d, flops %12.4e\n',it,flops);
               elseif i==2
                  fprintf('Gauss-Seidel      smoothing, #it: %4d, flops %12.4e\n',it,flops);
               else
                  fprintf('improved Jacobi   smoothing, #it: %4d, flops %12.4e\n',it,flops);
               end % if-elseif-else
           end % for i
           % -----------------------   END linear iteration   -----------------------
        
           
        
         elseif type_iteration==2
           % -----------------------   polynomial iteration   -----------------------
           if IsSPD
              fprintf('\nCG\n');
        
              if nu1~=nu2
                 fprintf('number of smoothing steps: %1d (pre), %1d (post)\n',nu,nu);
                 fprintf('number of recursive calls: %1d ', mu);
                 if mu==1
                    fprintf('(V-cycle)');
                 elseif mu==2
                    fprintf('(W-cycle)');
                 end % if-else
                 fprintf('\n');
              end % if
        
              for i=1:2
                  % auxillary vector r. It contains the residual and after that the 
                  % defect 
                  % correction for x
                  x=zeros(n,1);
                  r=b-Alist{1}*x;
                  bs=size(b,2);
                  flops(0);
           
                  % ----------------------- CG iteration loop -----------------------
                  % compute norm of the residual
                  nrm=norm(r,inf);
                  z=zeros(n,bs);
                  p=zeros(n,bs);
                  rho=0;
                  rho_old=1;
                  sigma=1;
                  it=0;
                  tol=nrm*sqrt(eps);
           
                  while nrm>tol
              
                        it=it+1;
                     
                        % ------------ Solve preconditioned system: Mz=r ------------
                        if i==1
                           % 1. Damped diagonal smoothing
                           z=MGPCall(r,Alist,Plist,Plist,nu,nu,mu,'Smoother',Dlist);
                        elseif i==2
                           % 2. Gauss-Seidel smoothing (post-smoothing is performed
                           % in reverse order, same number of pre- and post-smoothing
                           % steps)
                           z=MGPCall(r,Alist,Plist,Plist,nu,nu,mu,'SSmoother',GSFlist,'SSmoother',GSBlist);
                         else
                           % 3. improved Jacobi smoothing
                           z=MGPCall(r,Alist,Plist,Plist,nu,nu,mu,'Smoother',Jlist);
                         end % if-elseif-else
                         % --------- END Solve preconditioned system: Mz=r ----------
              
                         rho_old=rho;
                         % rho=r'*z
                         rho=r'*z;
                         if it==1
                            p=z;
        %                    tol=abs(rho)*sqrt(eps);
                         else
                            beta=rho_old\rho;
                            p=z+p*beta;
                         end % if-else it==1
              
                         z=Alist{1}*p;
                         % sigma=p'*A*p
                         sigma=p'*z;
                         alpha=sigma\rho;
                         x=x+p*alpha;
                         r=r-z*alpha;
        %                 nrm=abs(rho);
                         nrm=norm(r,inf);
                     
                  end % while nrm>tol
                  % ------------------- END CG iteration loop -----------------------
                  if i==1
                     fprintf('standard Diagonal smoothing, #it: %4d, flops %12.4e\n',it,flops);
                  elseif i==2
                     fprintf('Gauss-Seidel      smoothing, #it: %4d, flops %12.4e\n',it,flops);
                  else
                     fprintf('improved Jacobi   smoothing, #it: %4d, flops %12.4e\n',it,flops);
                  end % if-elseif-else
              end % for
            
           else   
              
              % ---------------    Some general preparations   ------------------
              % restart length
              RST=20;
              % Select whether the residual should be printed during the
              % iteration or not
              PRINT_RES=0;
              % decide whether the true residual and graphic information should be
              % displayed or not
              stat=0;
              
              % decide whether SVD should be used to solve the system with H or not
              % if USE_SVD==0, then it may happen that a restart has to be 
              % performed earlier than after l steps. This will be the case if H
              % has no longer full rank.
              USE_SVD=0;
              % information is printed out?
              PRINT_INFO=0;
        
              % Select choice of orthogonalization in GMRES
              % Case 0: use modified Gram-Schmidt  (standard, but hard to 
              %         parallelize)
              % Case 1: use classical Gram-Schmidt (easiest way to parallelize, but
              %                                     possibly loss of orthogonality)
              % Case 2: use Householder            (most stable version, but also 
              %                                     most expensive and hard to 
              %                                     parallelize)
              % Case 3: use modified Householder   (stable? version, as expensive 
              %                                 as Householder but easy to 
              %                                     parallelize)
              CHOICE_ORTH=0;
              if PRINT_INFO
                 if CHOICE_ORTH==0
                    fprintf('\nUse MODIFIED Gram-Schmidt in GMRES\n');
                 elseif CHOICE_ORTH==1
                    fprintf('\nUse CLASSICAL Gram-Schmidt in GMRES\n');
                 elseif CHOICE_ORTH==2   
                    fprintf('\nUse Householder in GMRES\n');
                 else      
                    fprintf('\nUse MODIFIED Householder in GMRES\n');
                 end; % if-elseif-else
              end % if PRINT_INFO
              
              % tolerance for residual in GMRES iteration
              RES_TOL=sqrt(eps);
              % maximum number of iterations
              MAX_IT=10*n+3;
              fprintf('\nGMRES(%d)\n',RST);
              if stat
                 clf;
              end % if
              % ---------------    Some general preparations   ------------------
        
              
      
              clr(1,:)=':r';clr(2,:)=':g';
              for ii=1:2
                  % --------------------- GMRES iteration loop ---------------------
                  % count for the number of iterations
                  x=zeros(n,1);
                  % Compute initial residual  = b-A*x0
                  r=zeros(n,1);
                  r=b-Alist{1}*x;
                  it=0;
                  flops(0);
                  % vectors containing residual information
                  res=[]; 
        
                  RST=min(n,RST);
                  y=zeros(n,1);
                  % norm of the residual
                  res=zeros(1,fix(1.5*n+RST));
                  res2=zeros(1,fix(1.5*n+RST));
                  % matrix with Arnoldi vectors AV=VH+...
                  V=zeros(n,RST+1);
                  % small Hessenberg matrix
                  H=zeros(RST+2,RST+1);
                  % additional parameters for Householder representation of V
if CHOICE_ORTH>=2 % -------------------
                  beta=zeros(1,RST+1);
if CHOICE_ORTH==3 % -------------------
                  T=zeros(RST+1,RST+1);
end % if CHOICE_ORTH==3 --------------
end % if CHOICE_ORTH>=2 ---------------
                  % auxilaury vector
                  Q=zeros(n,1);
                  % Parameters for Givens rotations
                  c=zeros(1,RST+1);
                  s=zeros(1,RST+1);   
           
               
% print residual information       
if PRINT_RES %%%%%%%%%%%%%%%%%%
                  fprintf('2-norm of the initial residual: %12.4e\n', norm(r,2));
end % if PRINT_RES %%%%%%%%%%%%%
  
                  % counter for total number of iterations
                  kk=1;
        
% print residual information       
if PRINT_RES % ----------------
                  fprintf('step %3d, ', kk);
end % if PRINT_RES -----------
        
                  % store history of the residual 
                  res(kk)=norm(r,2);
        
                  while (abs(res(kk))>RES_TOL*abs(res(1)) & kk<=MAX_IT)
                        if (kk>1)
                           % Compute the residual r = b-A*x 
                           r=b-Alist{1}*x;
                           res(kk)=norm(r,2);
                        end % if
        
                        % first Arnoldi vector
                        V(:,1)=r;
             
% Choice of reorthogonalization scheme       
if CHOICE_ORTH<2 % ------------------
                        V(:,1)=V(:,1)/res(kk);
else % CHOICE_ORTH>=2 
                        % compute Householder representation of r
                        [V(:,1),beta(1),MU]=HOUSE(V(:,1));
                        % Applying the Householder transformation to r will give a 
                        % multiple of the first unit vector. This multiple will be
                        % -sign(r(1))*MU.
                        if (r(1)>=0)
                           res(kk)=-MU;
                        else   
                           res(kk)=MU;
                        end % if-else
if CHOICE_ORTH==3 % -------------------
                        T(1,1)=1/beta(1);
end % if CHOICE_ORTH==3 --------------
end % if CHOICE_ORTH<2 ---------------
                 
if PRINT_RES % -----------------------
                        if (kk>1)
                           fprintf('\nstep %3d, ', kk);
                        end % if
                        fprintf('residual%16.8e', abs(res(kk))); 
                        semilogy(1:kk,abs(res(1:kk)),clr(ii,:)); hold on;
                        fprintf('\n'); 
end % if PRINT_RES ------------------
                
        
                        i=1;
                        % rhs is a vector which is used as monitor to check the 
                        % residual. Using rhs, one can avoid the update of x in all 
                        % steps until the iteration is terminated. 
                        % Algebraically we have rhs=V'*r and later rhs=G*V'*r, where G
                        % is the matrix with Givens rotations, which transforms H to
                        % upper triangular form.
                        rhs(1)=res(kk);
                        % flag for nonsingular transformed Hessenberg matrix
                        nsgl=1;
                        % control vector for ||H||
                        nrmH=zeros(RST+2,1);
                        % during the iteration the preconditioned residual will be 
                        % estimated. Ensure that the pseudo residual is small enough 
                        while (i<=RST & abs(res(kk))>RES_TOL*abs(res(1)) & nsgl & kk<=MAX_IT)
                              if (kk>1 & i==1)
if PRINT_RES % ----------------
                                 fprintf('RESTART GMRES\n');
end % if PRINT_RES -----------
                              end % if
        
                              
                              % Q=A*M^{-1}*V(:,i);
if CHOICE_ORTH<2 % ------------------
                              Q=V(:,i);
elseif CHOICE_ORTH==2 
                              % Compute V(:,i) from its Householder representation 
                              % HH_1*...*HH_i*e_i
                              Q=zeros(n,1);
                              Q(i)=1;
                              for k=i:-1:1
                                  Q(k:n)=ROWHOUSE(Q(k:n),V(k:n,k),beta(k));
                              end % for
else % CHOICE_ORTH==3
                              % Compute V(:,i) from its modified Householder representation 
                              % (I + V(:,1:i) T^{-1} V(:,1:i)') * e_i
                              Q=zeros(n,1);
                              Q(i)=1;
                              Q=Q+V(:,1:i)*(T(1:i,1:i)\V(i,1:i)');
end % if ---------------------------
                              % ------------------------------------------------------
                              % Solve the preconditioned system M*Q=Q         
                              if ii==1
                                 % 1. Damped diagonal smoothing
                                 Q=MGPCall(Q,Alist,Plist,Plist,nu1,nu2,mu,'Smoother',Dlist);
                              elseif ii==2
                                 % 2. Gauss-Seidel smoothing (post-smoothing is performed
                                 % in reverse order, same number of pre- and post-smoothing
                                 % steps)
                                 Q=MGPCall(Q,Alist,Plist,Plist,nu1,nu2,mu,'SSmoother',GSFlist,'SSmoother',GSBlist);
                              end % if-elseif-else
                              % -------------------------------------------------------
                              % Q = A * (M^{-1}*Q)
                              Q=Alist{1}*Q;
        
                              
                              % Compute next column of H 
if CHOICE_ORTH==0 % ----------------------
                              % perform modified Gram-Schmidt orthogonalization
                              for k=1:i
                                  H(k,i)=V(:,k)'*Q;
                                  Q     =Q-V(:,k)*H(k,i);
                              end % for
                              H(i+1,i)=norm(Q,2);
                              V(:,i+1)=Q/H(i+1,i);
elseif CHOICE_ORTH==1 % ----------------------
                              % perform classical Gram-Schmidt orthogonalization
                              H(1:i,i)=V(:,1:i)'*Q;
                              Q       =Q-V(:,1:i)*H(1:i,i);
                              H(i+1,i)=norm(Q,2);
                              V(:,i+1)=Q/H(i+1,i);
elseif CHOICE_ORTH==2 % ------------------
                              % Compute Householder representation of V(:,i+1)
                              % Step 1: Multiply with previous Householder transformations,
                              %         V(:,i+1) = HH_i*...*HH_1*Q
                              V(:,i+1)=Q;
                              for k=1:i
                                  V(k:n,i+1)=ROWHOUSE(V(k:n,i+1),V(k:n,k),beta(k));
                              end % for
                              % => H(1:i,i)=V(:,1:i)'*Q=V(1:i,i+1)
                              H(1:min(n,i+1),i)=V(1:min(n,i+1),i+1);
                              % Step 2: Compute Householder representation of V(:,i+1), i.e. 
                              % the submatrix V(i+1:n,i+1) will be transformed to a multiple
                              % of e_{i+1}
                              if i<n
                                 [V(i+1:n,i+1),beta(i+1),MU]=HOUSE(V(i+1:n,i+1));
                                 % Applying the Householder transformation to V(:,i+1) will
                                 % give a multiple of the (i+1). unit vector. This multiple
                                 % will be -sign(V_old(i+1,i+1))*MU=-sign(H(i+1,i))*MU.
                                 if (H(i+1,i)>=0)
                                    H(i+1,i)=-MU;
                                 else   
                                    H(i+1,i)=MU;
                                 end % if-else
                              else        
                                 beta(i+1)=-2; H(i+1,i)=0;
                              end % if
else % CHOICE_ORTH==3
                              % Compute modified Householder representation of V(:,i+1)
                              % Step 1: Multiply with previous Householder transformations,
                              %         V(:,i+1)= (I + V(:,1:i) T^{-*} V(:,1:i)')*Q
                              V(:,i+1)=Q+V(:,1:i)*(T(1:i,1:i)'\ (V(:,1:i)'*Q));
                              % => H(1:i,i)=V(:,1:i)'*Q=V(1:i,i+1)
                              H(1:min(n,i+1),i)=V(1:min(n,i+1),i+1);
                              % Step 2: Compute Householder representation of V(:,i+1), i.e. 
                              % the submatrix V(i+1:n,i+1) will be transformed to a multiple
                              % of e_{i+1}
                              if i<n
                                 [V(i+1:n,i+1),beta(i+1),MU]=HOUSE(V(i+1:n,i+1));
                                 V(1:i,i+1)=zeros(i,1);
                                 % Applying the Householder transformation to V(:,i+1) will
                                 % give a multiple of the (i+1). unit vector. This multiple
                                 % will be -sign(V_old(i+1,i+1))*MU=-sign(H(i+1,i))*MU.
                                 if (H(i+1,i)>=0)
                                    H(i+1,i)=-MU;
                                 else   
                                    H(i+1,i)=MU;
                                 end % if-else
                              else        
                                 beta(i+1)=-2; H(i+1,i)=0;
                              end % if
                              % Compute new column of T
                              T(i+1,i+1)=1/beta(i+1);
                              T(1:i,i+1)=-V(:,1:i)'*V(:,i+1);
                              % => HH_1*...*HH_{i+1} = I + V(:,1:i+1) T^{-1} V(:,1:i+1)'
end % -----------------------------------
        
        
                              % Transform actual H to upper triangular form
                              for k=1:i-1
                                  H(k:k+1,i)=ROWROT(H(k:k+1,i),c(k),s(k));
                              end % for
                              % Compute new Givens rotation
                              [c(i),s(i)]=GIVENS(H(i,i),H(i+1,i));
                              % Transform i. column   
                              H(i:i+1,i)=ROWROT(H(i:i+1,i),c(i),s(i));
                              % Transform rhs
                              rhs(i+1,1)=0;
                              rhs(i:i+1,1)=ROWROT(rhs(i:i+1,1),c(i),s(i));
        
                              % Will the transformed Hessenberg matrix become singular?
                              nrmH(1:i+1)=nrmH(1:i+1)+abs(H(1:i+1,i));
                              if abs(H(i,i))>n*eps*max(nrmH(1:i))
                                 i=i+1;
                                 kk=kk+1;
                              else        
                                 nsgl=0;
                                 if USE_SVD
                                    i=i+1;
                                    kk=kk+1;
                                 end % if
                              end % if-else       
                              res(kk)=rhs(i);
                                
                              
                              % if flag is set, compute the real residual
                              if stat          
                                 % test approximate solution
if USE_SVD % ----------------------------
                                 if nsgl 
                                    y=H(1:i-1,1:i-1)\rhs(1:i-1,1);
                                 else
                                    y=pinv(H(1:i-1,1:i-1))*rhs(1:i-1,1);
                                 end % if-else
else
                                 y=H(1:i-1,1:i-1)\rhs(1:i-1,1);
end; % if USE_SVD -----------------------                 
if CHOICE_ORTH<2 % ----------------------
                                 xx=V(:,1:i-1)*y;
elseif CHOICE_ORTH==2        
                                 xx=zeros(n,1);
                                 xx(1:i-1)=y;
                                 for k=i-1:-1:1
                                     xx(k:n)=ROWHOUSE(xx(k:n),V(k:n,k),beta(k));
                                 end % for
else % CHOICE_ORTH==3
                                 xx=zeros(n,1);
                                 xx(1:i-1)=y;
                                 xx=xx+V(:,1:i-1)*(T(1:i-1,1:i-1)\ (V(1:i-1,1:i-1)'*y));
end; % if CHOICE_ORTH<2 -----------------
                                 % ----------------------------------------------------
                                 % Solve the preconditioned system M*xx=xx
                                 if ii==1
                                    % 1. Damped diagonal smoothing
                                    xx=MGPCall(xx,Alist,Plist,Plist,nu1,nu2,mu,'Smoother',Dlist);
                                 elseif ii==2
                                    % 2. Gauss-Seidel smoothing (post-smoothing is performed
                                    % in reverse order, same number of pre- and post-smoothing
                                    % steps)
                                    xx=MGPCall(xx,Alist,Plist,Plist,nu1,nu2,mu,'SSmoother',GSFlist,'SSmoother',GSBlist);
                                 end % if-elseif-else
                                 % ----------------------------------------------------
                                 xx=x+xx;
                              end % if stat
                              
% print residual information           
if PRINT_RES  % --------------------------
                              fprintf('step %3d, ', kk);
                              fprintf('residual%16.8e', abs(res(kk))); 
                              semilogy(1:kk,abs(res(1:kk)),clr(ii,:)); hold on;
                              % if flag is set, display the real residual
                              if stat          
                                 fprintf(', true residual%12.4e', norm(b-Alist{1}*xx));
                              end % if stat
                              fprintf('\n');
end % if PRINT_RES ---------------------
                     
                        end % while
                        % END of up to RST steps of GMRES
        
                        % now compute approximate solution xsmall 
                        if (i>1)
if USE_SVD % ----------------------------
                           if nsgl 
                              y=H(1:i-1,1:i-1)\rhs(1:i-1,1);
                           else
                              y=pinv(H(1:i-1,1:i-1))*rhs(1:i-1,1);
                           end % if-else
else
                           y=H(1:i-1,1:i-1)\rhs(1:i-1,1);
end % if USE_SVD -----------------------                  
        
                % Select reorthogonalization scheme and corresponding computation of the
                % next approximate solution
if CHOICE_ORTH<2 % ----------------------
                                   % update x
                                   xx=V(:,1:i-1)*y;
elseif CHOICE_ORTH==2
                                   xx=zeros(n,1);
                                   xx(1:i-1)=y;
                           for k=i-1:-1:1
                               xx(k:n)=ROWHOUSE(xx(k:n),V(k:n,k),beta(k));
                           end % for
else % CHOICE_ORTH==3
                           xx=zeros(n,1);
                           xx(1:i-1)=y;
                           % update x
                           xx=xx+V(:,1:i-1)*(T(1:i-1,1:i-1)\ (V(1:i-1,1:i-1)'*y));
end % if CHOICE_ORTH<2 -----------------
                           % --------------------------------------------------------
                           % Solve the preconditioned system M*xx=xx
                           if ii==1
                              % 1. Damped diagonal smoothing
                              xx=MGPCall(xx,Alist,Plist,Plist,nu1,nu2,mu,'Smoother',Dlist);
                           elseif ii==2
                              % 2. Gauss-Seidel smoothing (post-smoothing is performed
                              % in reverse order, same number of pre- and post-smoothing
                              % steps)
                              xx=MGPCall(xx,Alist,Plist,Plist,nu1,nu2,mu,'SSmoother',GSFlist,'SSmoother',GSBlist);
                           end % if-elseif-else
                           % ---------------------------------------------------------
                           % update x
                           x=x+xx;
                        end % if
                  end % while
                  it=it+kk;
        
                  % ------------------- END GMRES iteration loop -------------------
                  if ii==1
                     fprintf('standard Diagonal smoothing, #it: %4d, flops %12.4e\n',it,flops);
                  elseif ii==2
                     fprintf('Gauss-Seidel      smoothing, #it: %4d, flops %12.4e\n',it,flops);
                  else
                     fprintf('improved Jacobi   smoothing, #it: %4d, flops %12.4e\n',it,flops);
                  end % if-elseif-else
                  
if PRINT_RES %%%%%%%%%%%%%%%%%%
                  r=b-Alist{1}*x;
                  fprintf('2-norm of the final residual: %12.4e\n', norm(r,2));
end % if PRINT_RES %%%%%%%%%%%%%
        
        
                  if stat
                     semilogy(1:length(res),abs(res),clr(ii,:));
                     hold on
                     ylabel('norm of the residual');
                     title('history of the residual in the 2-norm');
                  end % if
        
                  if abs(res(kk))>RES_TOL*abs(res(1)) & kk>MAX_IT
                     fprintf('\n*****     Warning! GMRESJ did not converge!     ***\n\n');
                  end % if
        
             end % for ii
             if stat
                hold off;
                xlabel(['iterations, res: `' clr(1,:) '`(dgl) ' ...
                                             clr(2,:) '`(Gauss-Seidel) ' ...
                                             clr(2,:) '`(impr. Jac.)']);
             end % if 
                  
          end % if-else IsSPD
          % ---------------------   END polynomial iteration   ---------------------
      end % if-else        
end % while        
        
        
        
        
